'Macro GFX Measure: adds graphic measurement arrows. can also start by deleting
'all graphic elements on screen. Loops until user presses cancel
'A. Pavageau; 10/10

Sub Main
    Dim App As femap.model
    Set App = feFemap()

	App.feAppMessage(FCM_ERROR,"Macro GFX Measure")

	'option: delete previous gxf elements
	Dim delPrevGFK As Long
	delPrevGFX = App.feAppMessageBox(3,"Do you want to delete all previous " & _
	"graphic elements?")

	Dim ar As femap.GFXArrow, txt As femap.text
	Set ar = App.feGFXArrow
	Set txt = App.feText

	Dim GFXSet As femap.Set
	Set GFXSet = App.feSet
	GFXSet.ID = 1

	If  delPrevGFX = FE_CANCEL Then
		Exit Sub
	ElseIf delprevGFX = FE_OK Then
		ar.DeleteAll(True,1)  'delete arrows
		App.feGFXSelect(GFXSet.ID,True,True)

		Dim txtSet As femap.Set
		Set txtSet = App.feSet

		While txt.Next
			txtSet.Add(txt.ID)
		Wend
		App.feDelete(FT_TEXT,txtSet.ID)  'delete text
		App.feViewRegenerate(0)
	End If

	Do  'infinite loop - user presses cancel to get out
    	Dim vecLength As Double, vecBase As Variant, vecDir As Variant
    	If App.feVectorPick("From where to where do you want to measure?", _
    	False,vecLength,vecBase,vecDir) = FE_CANCEL Then
    		Exit Sub
    	End If

    	ar.ID = GFXSet.Count+1
		ar.style = GAS_DOUBLE_LINE
		ar.lengthmode = GAM_ABSOLUTE
		ar.color = 24580  'thick red
		ar.x = vecBase(0) : ar.y = vecBase(1) : ar.z = vecBase(2)
		ar.dX = vecDir(0)*vecLength : ar.dY =vecDir(1)*vecLength
		ar.dZ = vecDir(2)*vecLength
		ar.Length = Sqr((ar.dX)^2+(ar.dY)^2+(ar.dZ)^2)

		ar.Put(ar.ID)
		GFXSet.Add(ar.ID)
		App.feGFXSelect(GFXSet.ID,True,True)

		txt.ModelPosition = True : 	txt.AllViews = True
		txt.DrawBorder = True : txt.BorderColor = FCL_BLACK
		txt.BackColor = FCL_WHITE : txt.color = FCL_BLACK
		txt.layer = 1
		txt.FontNumber = 4

		txt.ID = App.Info_NextID(FT_TEXT)
		txt.TextPosition(0) = ar.x+ar.dX/2
		txt.TextPosition(1) = ar.y+ar.dY/2
		txt.TextPosition(2) = ar.z+ar.dZ/2
		txt.text = editTxt(CStr(ar.Length*1))
		txt.Put(txt.ID)

		App.feViewRegenerate(0)  'regenerate active view so as to display textboxes
	Loop
End Sub

Function editTxt(txt As String) As String
	If InStr(txt,"E") <> 0 Then
		editTxt = Left(txt,4) & Right(txt,4) & """
	ElseIf Len(txt) > 5 Then
		editTxt = Left(txt,5) & """
	Else
		editTxt = txt & """
	End If
End Function
